#line 1 "C:/Users/Usuario/Documents/MikroC_pro_pic/keypad_4x4_ADC/kp_4x4_adc.c"


unsigned int rd_adc=0;
long volt=0;
short int aux=1;
char ch;

sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;


void set_up() {

 ANSEL = 0x04;
 TRISA = 0x04;
 ADCON1 = 0x82;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 CCP1CON = 0;
 CCP2CON = 0;
 TRISD0_bit=0;
 RD0_bit=0;
 PORTA = 0;
 Lcd_Init();
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_CLEAR);
}

 void LED() {
 RD0_bit=1;
 delay_ms(200);
 RD0_bit=0;
 delay_ms(200);

}
void volt_print() {
 ch = volt / 1000;
 Lcd_Chr(1,7,48+ch);
 Lcd_Chr_CP('.');
 ch = (volt / 100) % 10;
 Lcd_Chr(1,9,48+ch);
 ch = (volt / 10) % 10;
 Lcd_Chr_CP(48+ch);
 ch = volt % 10;
 Lcd_Chr_CP(48+ch);
}
void main() {
 set_up();
 Lcd_Out(1,1,"KEY:");
 Lcd_Out(1,12,"V");
 volt_print();
 while (1) {

 rd_adc = ADC_Read(2);
 delay_ms(10);
 volt= (long)rd_adc*5000;
 volt = volt /1023;
 if((volt<=5000) && (volt>4500)) Lcd_Chr(2,aux,'7'),aux++,LED(),volt_print();
 if((volt<=1670) && (volt>1650)) Lcd_Chr(2,aux,'4'),aux++,LED(),volt_print();
 if((volt<=2500) && (volt>2400)) Lcd_Chr(2,aux,'1'),aux++,LED(),volt_print();
 if((volt<=2000) && (volt>1900)) Lcd_Chr(2,aux,'*'),aux++,LED(),volt_print();
 if((volt<=3300) && (volt>3100)) Lcd_Chr(2,aux,'8'),aux++,LED(),volt_print();
 if((volt<=1095) && (volt>1030)) Lcd_Chr(2,aux,'5'),aux++,LED(),volt_print();
 if((volt<=1650) && (volt>1600)) Lcd_Chr(2,aux,'2'),aux++,LED(),volt_print();
 if((volt<=1320) && (volt>1270)) Lcd_Chr(2,aux,'0'),aux++,LED(),volt_print();
 if((volt<=840) && (volt>800)) Lcd_Chr(2,aux,'9'),aux++,LED(),volt_print();
 if((volt<=630) && (volt>590)) Lcd_Chr(2,aux,'6'),aux++,LED(),volt_print();
 if((volt<=720) && (volt>680)) Lcd_Chr(2,aux,'3'),aux++,LED(),volt_print();
 if((volt<=670) && (volt>630)) Lcd_Chr(2,aux,'='),aux++,LED(),volt_print();
 if((volt<=1430) && (volt>1400)) Lcd_Chr(2,aux,'%'),aux++,LED(),volt_print();
 if((volt<=910) && (volt>850)) Lcd_Chr(2,aux,'X'),aux++,LED(),volt_print();
 if((volt<=1110) && (volt>1095)) Lcd_Chr(2,aux,'-'),aux++,LED(),volt_print();
 if((volt<=1010) && (volt>950)) Lcd_Chr(2,aux,'+'),aux++,LED(),volt_print();
 Delay_ms(100);
 if(aux >16) aux=1;
 }
}
